//
//  air_bokeh_infer.h
//  bokeh_ios
//
//  Created by Jiayong Deng on 2021/3/31.
//

#ifndef air_bokeh_infer_h
#define air_bokeh_infer_h


#import <Foundation/Foundation.h>
#import <CoreML/CoreML.h>
#import <AVFoundation/AVFoundation.h>
#import <Vision/Vision.h>

//#define QUANTIZATION_COREML
//#import "bokeh.h"
//#import "bokeh_small.h"



#include <time.h>
#include <map>
#include <algorithm>
#include <string>
#include <vector>
#include <fstream>
#include <iostream>
#include <string.h>


#include "OneEuroFilter.h"

#include "mnn_seg.h"

using namespace std;
using namespace air;

template <typename T>
CVPixelBufferRef CreatePixelBuf(T  *indata, int width, int height, int channel, float scale);



class BoekhInfer
{
public:
    BoekhInfer();
    ~BoekhInfer(){};
    void release();
    
        // 构建计算图，加载模型
    int Create(int flag);
    
        //处理
    void Process(air8u *src_rgb, int src_width_, int src_height_, int rotate_degree, uint8_t *mask);
    
    void Process_test(air8u *src_nv21, int src_width, int src_height, int rotate_degree, uint8_t *mask);
    
    void Process_test_1(air8u *src_nv21, int src_width_, int src_height_, int rotate_degree, uint8_t *mask);

// private:
public:
    
    //print log file for inference time
    bool printLogTxtFile;
    fstream m_time_log;
    
    //load model
    int model_flag;
    //bokeh *model;
    //bokeh_small *model_small;
    MnnSeg *seg_net_ = NULL;
    char *chars_net = NULL;

    
    //net input w and h
    int m_net_in_w;
    int m_net_in_h;
    int m_net_in_c;
    
    //net output w and h (mask)
    int m_net_out_w;
    int m_net_out_h;
    int m_net_out_c;
    
    //input image
    int m_src_w;
    int m_src_h;
    
    //填充黑边
    int m_src_size;
    uint8_t *m_src_img_tmp;
    
    int new_bg_w;
    int new_bg_h;
    int offset_length_x;
    int offset_length_y;
    
    //coreml input
    MLMultiArray *imageArray;
    
    //mask image
    unsigned char *m_output; //net output size
    
    float *clipcpyfloat;
    
    int last_src_width;
    int last_src_height;
    int last_src_degree;
    bool m_src_img_change;
    
    //tracking every element after softmax
    OneEuroFilter *tracker;
    
    uint8_t *mask_result;
    
    //隔帧处理
    float input_fps;
    int fps_width;
    int fps_height;
    float fps_low;
    float fps_high;
    float adjust_fps;
    int diffpix_thres_low;
    int diffpix_thres_high;
    int jump_num;
    double time_ms_stamp;
    
    air8u *grey_pre;
    air8u *grey_cur;
    uint8_t *binary_mask;
    uint8_t *enrode_mask;
    uint8_t *dilate_mask;
    uint8_t *tile_mask;
    bool this_is_the_first_frame;
    bool Do_Inference;
};







#endif /* air_bokeh_infer_h */
