#include <MNN/ImageProcess.hpp>
#include <MNN/Interpreter.hpp>
#include <MNN/AutoTime.hpp>
#include <memory>
#include <vector>


using namespace MNN;
using namespace MNN::CV;
class MnnSeg
{
public:
    MnnSeg();
    ~MnnSeg();

    void init_model(const char *model_path, const void* buffer, size_t size);

    void get_in_shape(std::vector<int> &in_shape);

    void get_out_shape(std::vector<int> &out_shape);

    void *get_inputtensor();

    void *get_outputtensor();

    void run_model();

    void mnn_release();
    

private:
    std::shared_ptr<Interpreter> seg_interpreter_;
    Session *seg_session_;
    Tensor *input_tensor_;
    Tensor *output_tensor_;
    Tensor *result_tensor_;
    Tensor *in_tensor_;
};